/*
 *  GOL - Game of life simulation software
 *  Copyright (C) 1996 Michael Raymond Brown
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 *  Author: Michael Raymond Brown
 *  EMail:  michael@arrakeen.demon.co.uk
 *  WWW:    http://www.arrakeen.demon.co.uk/
 *  Address:  Michael Brown
 *            Kia Ora
 *            Brook Street
 *            Great Bromley
 *            Nr Colchester
 *            Essex
 *            CO7 7HX
 *            England
 */


#include "App.h"
#include "Window.h"
#include "Button.h"
#include "MsgBox.h"
#include "VScrollArea.h"
#include "Image.h"
#include <iostream.h>
#include <stdlib.h>

xwApp*		app;
class test_app* mainwin;


class test_app : public xwHandler
   {public:
	xwWindow*	window;
	xwVScrollArea*	scroll;
	xwImage*	image;

	int pixarray[64];

	int old  ;
	int old_x;
	int old_y;
	int colour;

	test_app()
	   {int count;

	    window = new xwWindow(app, "test app");
	    scroll = new xwVScrollArea(window);
	    scroll->setSize(320, 200);

	    window->setHandler(this, 0);
	    scroll->setHandler(this, 1);
	    scroll->setRange(256, 256);

	    old=0;

	    window->show();

	    image = app->getImage(256, 256);
	    colour = -1;

	    for (count=64; count--; )
		 pixarray[count]=app->get_grey(count*4);
	   }
	~test_app()
	   {delete image;
	   }

	void onResize(xwWidget* from, int index)
	   {int w, h;
	    from->getSize(&w, &h);
	    cerr << "Object " << index << " resized to " << w << "," << h << '\n';
	   }
	void onExpose(xwWidget* from, int index, int x, int y, int w, int h)
	   {cerr << "Object " << index << " exposed   pos=" << x << "," << y << "  size=" << w << "," << h << '\n';
	    image->putImage(0, 0, scroll);
	   }
	void onDestroy(xwWindow* from, int index)
	   {delete app;
	    exit(0);
	   }

	void mouseDown(xwWidget* from, int index, int button, int x, int y)
	   {cerr << "mouseDown=" << button << "  x=" << x << "  y=" << y << "\n";
	    if (!old)
	       {old=1;
		old_x=x;
		old_y=y;
	   }   }
	void mouseUp(xwWidget* from, int index, int button, int x, int y)
	   {cerr << "mouseUp=" << button << "  x=" << x << "  y=" << y << "\n";
	    if (old && !button)
	       {old=0;
	   }   }
	void mouseMove(xwWidget* from, int index, int button, int x, int y)
	   {cerr << "mouseMove=" << button << "  x=" << x << "  y=" << y << "\n";
	    if (old)
	       {
		// if (colour == -1) colour = app->get_rgb(0xd0, 0x50, 0x20);
/*
		image->line(old_x, old_y, x, y, colour);
		old_x=x;
		old_y=y;
*/
		image->multiPlot(x-4, y-4, 8, 8, pixarray, 8);
		image->putImage(0, 0, scroll);
	   }   }
   };


int main(int argc, char** argv)
   {
    app = new xwApp("Test application", argc, argv);
    mainwin = new test_app();
    app->start();
    return 0;
   }

